 {***************************************************************************
                      Fonction random() du Turbo Pascal

              Graine permet de gnrer 32 blocs de 2^27 nombres
                 pseudo-alatoires conscutifs indpendants.

  Graine [-32..-1] U [1..32],
      si Graine < 0 la gnration s'effectue
                           ? partir de la fin de bloc en "marche arrire"
      si Graine > 0 la gnration s'effectue
                           ? partir du dbut de bloc en "marche avant"

   ( Prcision du partage 1/140. Fichier d:\TP\TEST\RANDOM\RECHA_TP.PAS )
 ***************************************************************************}

 unit aleatp ;

 interface

 function  random : double ;

 function  random_(cc : longint) : longint ;

 procedure randomize ;

 procedure randseed_(rs : integer) ;

 procedure random_seed ;

 var     randseed : longint ;

 {**************************************************************************}

 implementation

 uses    biblio ;

 const   graine : array[0..31] of word =
            (   1, 4031, 9318, 7858, 6433, 6082, 5651, 5520, 9861,
             8920, 4934, 8740, 7316, 4305, 3774, 1662, 3491, 7506,
             9494, 5877, 2004, 2110, 1670, 9108, 5926, 1390, 1657,
             9918, 6623, 2748, 4189, 1296) ;

 var     a, c, b, d : longint ;
         demi : double ;
         m : integer ;

 {$l d:\tp\compiler\random.obj}

 function random : double ; external ;

 function random_(cc : longint) : longint ; external ;

 procedure random_seed ; external ;

 procedure randomize ;

 var     timer : word absolute $40:$6c ;

 begin
   randseed := graine[timer and $1f] ;
 end ;

 procedure randseed_(rs : integer) ;

 begin
   if (abs(rs) > 32) or (rs = 0) then
      arret('Entre incorrecte dtecte par la procdure RANDSEED') ;
   if rs > 0 then
      begin
         a := d ;
         c := 1 ;
         randseed := graine[rs - 1] ;
      end
   else
      begin
         a := -b ;
         c := b ;
         randseed := graine[abs(rs) mod 32] ;
      end
 end ;

 begin
   randseed :=  1 ;
   d := $08088405 ;
   b := 649090867 ;
   demi := 0.5 ;
   m := -32 ;
   a := d ;
   c := 1 ;
 end.

 {***************************************************************************
                      Fonction random() du Turbo Pascal
 ***************************************************************************}
