 (* Parcours du cavalier *)

 let dpx = [|1; 2; 2; 1; -1; -2; -2; -1|] ;;
 let dpy = [|2; 1; -1; -2; -2; -1; 1; 2|] ;;

 let echec = make_matrix 12 12 (-1) ;;

 let pos_x = ref 2 and pos_y = ref 2 ;;

 let affiche () =
    print_newline () ;
    for i = 2 to 9 do
       for j = 2 to 9 do
          print_string(" ") ;
          if echec.(i).(j) < 10 then print_string(" ") ;
          print_int(echec.(i).(j)) ;
       done ;
       print_newline () ;
    done ;;

 let init () =
    for i = 2 to 9 do
       for j = 2 to 9 do
          echec.(i).(j) <- 0 ;
       done ;
    done ;;

 let favorable x y =
    let count = ref 0 in
       for i = 0 to 7 do
          if echec.(x + dpx.(i)).(y + dpy.(i)) = 0 then count := !count + 1 ;
       done ;
    !count ;;

 let possible n =
    let min = ref 9 and coups = ref 8 in
       for i = 0 to 7 do
          if echec.(!pos_x + dpx.(i)).(!pos_y + dpy.(i)) = 0 then
                coups := favorable (!pos_x + dpx.(i)) (!pos_y + dpy.(i)) ;
          if !coups < !min then min := !coups ;
       done ;
    !min = favorable (!pos_x + dpx.(n)) (!pos_y + dpy.(n)) ;;

 let rec next n =
    echec.(!pos_x).(!pos_y) <- n ;
    if n = 64 then affiche ()
    else
       for i = 0 to 7 do
          if echec.(!pos_x + dpx.(i)).(!pos_y + dpy.(i)) = 0 then
             if possible i then
                begin
                   pos_x := !pos_x + dpx.(i) ;
                   pos_y := !pos_y + dpy.(i) ;
                   next (n + 1) ;
                   pos_x := !pos_x - dpx.(i) ;
                   pos_y := !pos_y - dpy.(i) ;
                end ;
       done ;
    echec.(!pos_x).(!pos_y) <- 0 ;;

 init () ;
 next 1 ;;

 (* Parcours du cavalier *)

